program erdos (input, output);

type TIndex = 1..32000;
   pErd	    = ^TErd;
   Terd	    = record
		 i : integer;
		 p : pErd;
	      end;
      
var n, p, rn : integer;
   mat	     : array[TIndex] of pErd;
   names     : array[TIndex] of string[40];
   erdNr     : array[TIndex] of integer;
   f	     : text;
   caseNr    : integer;

function lookUp(n :  string): integer;
var i :  integer;
begin
   for i:=1 to rn do begin
      if names[i]=n then begin
	 lookUp:=i;

	 exit;
      end;
   end;
   inc(rn);
   names[rn]:=n;
   lookUp:=rn;
   writeln('                       ', n, ' ', i);   
end; { lookUp }

procedure include(j,i :integer );
var p		      : pErd;
begin
   p:=mat[j];
   while p<>nil do begin
      if p^.i=i then exit;
      p:=p^.p;
   end;
   writeln('                 ', i, j);
   new(p);
   p^.p:=mat[j];
   p^.i:=i;
   mat[j]:=p;
end; { include }

function conn(i,j :integer ):boolean;
var p		      : pErd;
begin
   conn:=false;
   p:=mat[j];
   while p<>nil do begin
      if p^.i=i then conn:=true;
      p:=p^.p;
   end;
end; { conn }

procedure readPapers;
var l, i, j,start, nAuth : integer;
   auth		       : array [1..300] of integer;
   line		       : string[250];
   comma	       : boolean;
begin
   for l:=1 to 32000 do
      mat[l]:=nil;
   rn:=0;
   for l:=1 to p do begin
      readln(f, line);
      nAuth:=0; start:=1; comma:=false;
      for i:=1 to length(line) do begin
	 if (line[i]=',') and not comma then comma:=true
	 else if comma and ( (line[i]=',') or (line[i]=':') ) then begin
	    inc(nAuth);
	    auth[nAuth]:=lookUp(copy(line, start, i-start));
	    start:=i+2;
	    comma:=false
	 end;
	 if (line[i]=':') then break;
      end; { for in line }

      for i:=1 to nAuth do
	 for j:=1 to nAuth do
	    include(i,j);
      
   end; { for lines }
end; { readPapers }

procedure kill(var s :  pErd);
var p :  pErd;
begin
   while s<>nil do begin
      p:=s;
      s:=s^.p;
      dispose(p);
   end;
end; { kill }
   
procedure calc;
var i, akt, d : integer;
label next;
begin
   for i:=1 to rn do erdNr[i]:=MAXINT;
   akt:=lookUp('Erdos, P.');
   d:=0;
   erdNr[akt]:=0;
   repeat
      for i:=1 to rn do
	 if conn(akt, i) and (erdNr[i]>d+1) then
	     erdNr[i]:=d+1;
      repeat inc(akt);
	 if erdNr[akt]=d then goto next;
      until akt>rn;
      inc(d);
      for akt:=1 to rn do
	 if erdNr[akt]=d then goto next;
      break;
next: 
   until akt>rn;   


   for i:=1 to 32000 do kill(mat[i]);
end;

procedure print;
var i, d : integer;
   name	 : string[40];
begin
   for i:=1 to n do begin
      readln(f, name);
      d:=erdNr[lookUp(name)];
      write(name, ': ');
      if d=MAXINT then writeln('infinity')
      else writeln(d);
   end;
end; { print }
   

begin
   assign(f, 'erdos.in');
   reset(f);
   caseNr:=0;
   while true do begin
      inc(caseNr);
      readln(f, p, n);
      if p+n= 0 then break;
      writeln('Database #1');
      readPapers;
      calc;
      print;
      writeln;
   end;   
   close(f);
end.
  


