program railroad;

const
   maxCities	  = 100;
   CNameL	  = 80;
   (* UNREACHABLE = -1; *)
   maxTrains	  = 1000;
   maxStops	  = 100;
   NOCITY	  =  0;

type
   tTime     = longint;
   tCityName = string[CNameL];
   tCity     = record
		  name	     : tCityName;
		  latestTime : tTime;
		  besucht    : boolean;
	       end;	     
   tCities   = array[1..maxCities] of tCity;
   tCNr	     = NOCITY .. maxCities;
   tCitTim   = record
		  CNr  : tCNr;
		  time : tTime;
	       end;    
   tTrain    = array[1..maxStops] of tCitTim;
   tTrains   = array[1..maxTrains] of tTrain;

var
   inf	     : text;
   anzCities : longint;
   cities    : tCities;
   sCity     : tCNr;
   dCity     : tCNr;
   sTime     : tTime;
   Trains    : tTrains;
   anzTrains : longint;

function cName2Nr(cn : tCityName) : tCNr;
var i :  tCNr;
begin
   cName2Nr := NOCITY;
   for i := 1 to anzCities do
      if Cities[i].name = cn then
      begin
	 cName2Nr := i;
	 exit;
      end;
end; { cName2Nr }

function c2d(c :  char):integer;
begin
   c2d := ord(c)-ord('0');
end;

function str2Time(str :  string) : tTime;
begin
   str2Time := ((c2d(str[1])*10 + c2d(str[2])) * 60) +
   (c2d(str[3])*10) + c2d(str[4]);
end; { str2Time }

function d2c(d :  integer) : char;
begin
   d2c := chr(d + ord('0'));
end; { d2c }
    
function time2Str(t :  tTime) : string;
var h, m :  integer;
begin
   h:=t div 60;
   m := t mod 60;
   time2Str := d2c(h div 10) + d2c(h mod 10) + d2c(m div 10) + d2c(m mod 10);
end; { time2Str }
    

procedure readStop(var stop : tCitTim);
var zei	:  string;
begin
   readln(inf, zei);
   stop.CNr := cName2Nr(copy(zei, 6, length(zei)-5));
   stop.time := str2Time(copy(zei, 1, 4));
end; { readStop }

function liesEing : boolean;
var cn	    : tCityName;
   cNr	    : tCNr;
   TNr	    : longint;
   anzStops : longint;
   sNr	    : longint;
   zei	    : string;
begin
   liesEing:=false;
   read(inf, anzCities);
   if anzCities = 0 then exit;
   for cNr := 1 to anzCities do
   begin
      readln(inf, cities[cNr].name);
      (* cities[cNr] := UNREACHABLE; *)
   end;
   read(inf, anzTrains);
   for tNr := 1 to anzTrains do
    begin
       read(inf, anzStops);
       for sNr := 1 to anzStops do
	  readStop(trains[tNr][sNr]);
       for sNr := anzStops+1 to maxStops do
	  trains[tNr][sNr].CNr := NOCITY;
   end;
   (*readTime(sTime);*)
   radln(inf, zei);
   sTime := str2Time(zei);
   readln(inf, cn);
   sCity := cName2Nr(cn);
   readln(inf, cn);
   dCity := cName2Nr(cn);
   liesEing:=true;
end; { liesEing }

function hm2time(h, m :  integer) : tTime;
begin
   hm2time := h*60 +m;
end; { hm2time }

procedure suchAbfZeit(var abfZeit : tTime);

var
   nextCity : tCNr;
   cNr	    : tCNr;
procedure suchStadt;
var
   time	: tTime;
begin
   nextCity := NOCITY;
   time := hm2Time(-1,0);
   for cNr := 1 to anzCities do
      if not Cities[cNr].besucht then
	 if Cities[cNr].latestTime>time then
	 begin
	    time := Cities[cNr].latestTime;
	    nextCity := cNr;
	 end;
end; { suchStadt }

var cPos, pPos : tCNr;
   praktTime   : tTime;
   zNr	       : longint;

begin
   (* alle Staedte unbesucht machen *)
   for cNr := 1 to anzCities do
      with Cities[cNr] do
      begin
	 latestTime := hm2time(-1, 0);
	 besucht    := false;
      end;
   
   (* Zug suchen, der am Ziel nicht spaeter als ankZeit ankommt, aber mglichst Spaet *)
   (* davon die Zeit *)
   praktTime := hm2time(-1,0);
   for zNr := 1 to anzTrains do
   begin
      cPos := cPosition(zNr, dCity);
      if cPos>1 then
      begin
	 T := Trains[zNr][cPos].time;
	 if (T<=ankZeit) and (T>praktTime) then
	    praktTime := T;
      end;
   end;
   Cities[dCity].latestTime := praktTime;

   suchStadt;
   while nextCity<>NOCITY do
   begin
      if nextCity = sCity then
      begin
	 abfZeit := Cities[sCity].latestTime;
	 break;
      end
      else begin
	 Cities[nextCity].besucht:=true;
	 for zNr := 1 to anzTrains do
	 begin
	    cPos := cPosition(zNr, nextCity);
	    if cPos>1 then
	       for pPos := 1 to cPos - 1 do
	       begin
		  if Cities[Trains[zNr][pPos].CNr].latestTime < Trains[zNr][pPos].time then
		     Cities[Trains[zNr][pPos].CNr].latestTime := Trains[zNr][pPos].time;
	       end;
	 end;
      end;
      suchStadt;
   end;
end;

function verb : boolean;
var
   abfZeit, ankZeit : tTime;
begin
   ankZeit := sTime;
   abfZeit := hm2time(25,00);
   while (ankZeit <= hm2time(24,00)) and (abfZeit > hm2time(24,00)) do
   begin
      suchAbfZeit(abfZeit);
      if abfZeit<=hm2time(24,00) then
      begin
	 writeln('Departure ', time2Str(abfZeit), ' ', Cities[sCity]);
	 writeln('Arrival   ', time2Str(ankZeit), ' ', Cities[dCity]);
      end;
      inc(ankZeit);
   end;
end; { verb }


var
   probC :  longint;

begin
   assign(inf, 'railroad.in');
   reset(inf);
   probC := 1;
   while liesEing do
   begin
      writeln('Scenario #', probC);
      if not verb then writeln('No connection');
      writeln;
      inc(probC);
   end;
   close(inf);
end.